#pragma once

typedef unsigned char byte;
typedef unsigned word;
#define NOINIT __attribute__((section(".noinit")))
#define UNUSED __attribute__((unused))
#define elemof(x) (sizeof(x)/sizeof(*(x)))
#define nobreak
// Versioning
constexpr char DATE_H = (__DATE__[7]-'0')*10+__DATE__[8]-'0';
constexpr char DATE_Y = (__DATE__[9]-'0')*10+__DATE__[10]-'0';
constexpr char DATE_M =
    __DATE__[2]=='n' ? (__DATE__[1]=='a' ? 1 : 6)
  : __DATE__[2]=='b' ? 2
  : __DATE__[2]=='r' ? (__DATE__[0]=='M' ? 3 : 4)
  : __DATE__[2]=='y' ? 5
  : __DATE__[2]=='l' ? 7
  : __DATE__[2]=='g' ? 8
  : __DATE__[2]=='p' ? 9
  : __DATE__[2]=='t' ? 10
  : __DATE__[2]=='v' ? 11
  :		       12;
constexpr char DATE_D = (__DATE__[4]&0x0F)*10 + __DATE__[5]-'0';

// Vier Schalter
#define HID 0	// HID benutzen oder nicht?
#define WUB 1	// WebUSB/WinUSB benutzen oder nicht?
#define CDC 0	// CDC benutzen oder nicht?
#define IAD (HID|WUB)	// Interface Association Descriptor benutzen oder nicht? (Nur in Verbindung mit CDC)

namespace usb{
// you might want to change the buffer size, up to 64 bytes.
// The host reserves your bandwidth because this is an interrupt
// endpoint, so it won't be available to other interrupt or isync
// endpoints in other devices on the bus.
 enum{
  EP0SSH = 4,	// EP0: Control 16 Byte
  EP1SSH = 4,	// EP1: HID-Interrupt 16 Byte
  EP2SSH = 4,	// EP2: CDC-Status 16 Byte
  EP3SSH = 5,	// EP3: CDC-Daten C->PC 322 Byte
  EP4SSH = 5,	// EP4: CDC-Daten PC->C 322 Byte
  EP3DB = 2,	// EP0..2 knnen nur 1 Puffer
  EP4DB = 2,
 };

 void init();		// initialize everything
 extern byte configval;	// is the USB port configured
 void poll();
 void pollEp0();

 namespace hid{
  void onSetReport(unsigned type_id,unsigned wLength);
  void onGetReport(unsigned type_id,unsigned wLength);
 }
 
 namespace cdc{
  extern struct DCB{
   enum eStopbits{one,onehalf,two};
   enum eParity{none,odd,even,mark,space};
   unsigned long baudrate;
   byte stopbits,parity,databits;
   operator byte*() {return (byte*)this;}
  }dcb;
  void onRtsDsr(byte rts_dsr);
  void onDcb();
  void onSendBreak();
 }

 void onSof();
}
